      program chiral
c
c     bohren diss
c     FORTRAN code listed in 
c     C.F. Bohren "Light  scattering by optically active particles" PhD 1975, 
c     coded by Ute Comberg, IWT, Bremen, 28.4.2000	
c
c 
      implicit none
      integer i,j,num,nmx
c EXTENDED
c      real*16 theta(200) 
c      real*16 n2,lamda,rn,rconst,rpi,test,snorm,rad,x,
c     &        S11,S12,S13,S14,S34,SX
c      real*16 Sum1,Sum3,Sum4,QscatL,QscatR,QextL,QextR,Qdiff,Qsdif
c      complex*32 Sum2
c      complex*32 ai, an, bn, cn, Dn(2,2000), Tn, Xi, Xi1, Xi2
c      complex*32 Ans(2), Bns(2), Vns(2), Wns(2)
c      complex*32 S1(200,2), S2(200,2), S3(200,2)
c      complex*32 nr, nl, mrl(2), mm
c      complex*32 Pi(200),Pi1(200),Pi2(200),Tau(200),Tau1(200),Tau2(200)
c      complex*32 const, amu(200)
c DOUBLE
      real*8 theta(181) 
      real*8 n2,lamda,rn,rconst,rpi,test,snorm,rad,x,
     &        S11,S12,S13,S14,S34,SX
      real*8 Sum1,Sum3,Sum4,QscatL,QscatR,QextL,QextR,Qdiff,Qsdif
      complex*16 Sum2
      complex*16 ai, an, bn, cn, Dn(2,2000), Tn, Xi, Xi1, Xi2
      complex*16 Ans(2), Bns(2), Vns(2), Wns(2)
      complex*16 S1(181,2), S2(200,2), S3(200,2)
      complex*16 nr, nl, mrl(2), mm
      complex*16 Pi(181),Pi1(181),Pi2(181),Tau(181),Tau1(181),Tau2(181)
      complex*16 const, amu(181)
c SINGULAR
c     real   theta(200) 
c     real   n2,lamda,rn,rconst,rpi,test,snorm,rad,x,
c    &        S11,S12,S13,S14,S34,SX
c     real   Sum1,Sum3,Sum4,QscatL,QscatR,QextL,QextR,Qdiff,Qsdif
c     complex    Sum2
c     complex    ai, an, bn, cn, Dn(2,2000), Tn, Xi, Xi1, Xi2
c     complex    Ans(2), Bns(2), Vns(2), Wns(2)
c     complex    S1(200,2), S2(200,2), S3(200,2)
c     complex    nr, nl, mrl(2), mm
c     complex    Pi(200),Pi1(200),Pi2(200),Tau(200),Tau1(200),Tau2(200)
c     complex    const, amu(200)
      intrinsic abs
    9 format (1X,E13.6)
   10 format (1X,F5.1,3X,E13.6)
   11 format (1X,'QscatL=',E13.6,6X,'QscatR=',E13.6,/
     &        1X,'QextL =',E13.6, 6X,'QextR =',E13.6)
c
c   
c     n: Refraktionsi.(r/l)
c     m: rel. Refrakt. (r/l/mittel)
c
c     S1, S2, S3 : trans.Matrix-Elements
c
c     const : dummy
c
      open(unit=10,file='streu.dat',status='unknown')
      open(unit=11,file='streuS1.dat',status='unknown')
      open(unit=12,file='streuS2.dat',status='unknown')
c     open(unit=13,file='streuS13.dat',status='unknown')
c     open(unit=14,file='streuS14.dat',status='unknown')
c     open(unit=15,file='streuS34.dat',status='unknown')

c
c
c*****Entry
c
c     rad: Radius
c     num: Anzahl der Winkelschritte
c     n2:  Refraktionindex der Umgebung
c     lamda: Wellenlaenge
c
c  x=1.0
      rad= 0.030239439
c  x=1.5
c     rad= 0.045359159
      lamda= 0.19
      num= 181
c     nr=(1.213,0.)
c     nl=(1.218,0.)
c     nr=(1.123,0.)
c     nl=(1.308,0.)
      nr=(1.334,0.)
      nl=(1.334,0.)
      n2=1.0
c
c****** angles
      do 15 j=1,num
         theta(j)=0.0 + dble(j-1) * 180./dble(num-1)
   15 continue
c
c     x: size par.
c
      ai = cmplx(0.0,1.0)
      rpi = acos(-1.)
      x = n2* 2.*rpi*rad/lamda
c     write(*,*)'size-Parameter: ?'
c     read(*,*)x
c     write(*,'(A,F7.4)')'size-Parameter: ',x

      snorm=1./(rpi*x**2)
      mrl(1) = nr/n2
      mrl(2) = nl/n2
      mm = (mrl(1) + mrl(2))/2.
      write(*,'(A,2E10.4,A,2E10.4)')'nr= ',mrl(1),' nl= ',mrl(2)
      write(*,'(A,2E10.4)')'m= ',mm
c
c****** Dn:
c
      nmx = 1.1* abs(mm)*x + 1.
      if (nmx.lt.151) nmx =151
      if (nmx.gt.2000) nmx=2000
      do i=1,2
         Dn(i,nmx)= cmplx(0.0,0.0)
         const= 1./(mrl(i)*x)
         do j=1,(nmx-1)
            Dn(i,nmx-j)=(nmx-j+1)*const
     &     -(1.0)/((nmx-j+1)*const+Dn(i,nmx-j+1))
         enddo
      enddo
c****** amu: mue, argument of Pi & Tau

      do j=1,num
         amu(j) = cos(rpi*theta(j)/180.)
      enddo
c****** Initialize transf. matrix

      do i=1,2
         do j=1,num
            S1(j,i) = cmplx(0.0,0.0)
            S2(j,i) = S1(j,i)
            S3(j,i) = S2(j,i)
         enddo
      enddo
c****** Initialize Xi, Pi, Tau

      Xi1 = cmplx(sin(x),-cos(x))
      Xi2 = cmplx(cos(x),sin(x))

      do j=1,num
         Pi1(j) = 0.0
         Pi2(j) = 0.0

         Tau1(j)= 0.0
         Tau2(j)= 0.0

         Pi(j)  = 1.
         Tau(j) = amu(j)
      enddo

c****** series expansion up to test < 10**-14
      rn = 1.
      Sum1=0.0
      Sum2 = dCMPLX(0.0,0.0)
      Sum3=0.0
      Sum4=0.0
c****** computation of the coefficients an, bn, cn

  100 Xi = (2.*rn -1.)* Xi1 /x - Xi2
      
      Tn = rn * Xi /x - Xi1
      
      Xi2 = Xi1
      Xi1 = Xi

      do i =1,2
         Ans(i) = Dn(i,rn) * real(Xi) /mm
         Bns(i) = Ans(i) + real(Tn)
         Ans(i) = Ans(i)* (mm)**2 + real(Tn)

         Vns(i) = Dn(i,rn) * Xi /mm
         Wns(i) = Vns(i) + Tn 
         Vns(i) = Vns(i) * (mm)**2 + Tn
      enddo
c
      const = Wns(2) * Vns(1) + Vns(2) * Wns(1)

      an = (-1.)*(Wns(2) * Ans(1) + Ans(2) * Wns(1)) /const
      bn = (-1.)*(Bns(2) * Vns(1) + Vns(2) * Bns(1)) /const
      cn = (-1.)*ai *mm * (Bns(1) * Wns(2) - Bns(2) * Wns(1)) /const

c******filling of the trans. matrix

      rconst = (2.* rn + 1.) /(rn**2 + rn)

      do j=1,num
         S1(j,1) = S1(j,1) - rconst * (an * Tau(j) + bn * Pi(j))
         S2(j,1) = S2(j,1) - rconst * (an * Pi(j) + bn * Tau(j))
         S3(j,1) = S3(j,1) - rconst * cn * (Pi(j) + Tau(j))
      enddo

c******* convergation criteria
      Sum1=Sum1+dble((2.*rn+1.)*(-an-bn))
      Sum2=Sum2+(2.*rn+1.)*cn
c
      test=(abs(an))**2+(abs(bn))**2+2.*(abs(cn))**2
      Sum3=Sum3+test*(2.*rn+1.)
      Sum4=Sum4+(2.*rn+1.)*dble((CONJG(an)+CONJG(bn))*cn)

      if (test.lt.1.0E-14) goto 300

c******* Pi, Tau

      rn = rn+1
      rconst = 2.* rn - 1.

      do j=1,num
         Pi2(j)  = Pi1(j)
         Pi1(j)  = Pi(j)
         Tau2(j) = Tau1(j)
         Tau1(j) = Tau(j)
         Pi(j)   = rconst/(rn -1.)*amu(j)* Pi1(j) - rn/(rn -1.) *Pi2(j) 
         Tau(j) = amu(j) *(Pi(j) - Pi2(j)) 
     1 - rconst*(1- amu(j)**2)*Pi1(j) + Tau2(j)
      enddo

      goto 100

c********* end of main loop

  300 rn =rn
      QextL=(2./X**2)*Sum1
      QextR=QextL
      Qdiff=(4./X**2)*REAL(Sum2)
      QextL=QextL-Qdiff
      QextR=QextR+Qdiff
      QscatL=(2./X**2)*Sum3
      QscatR=QscatL
      Qsdif=(4./X**2)*Sum4
      QscatL=QscatL+Qsdif
      QscatR=QscatR-Qsdif
c
      write(10,11) QscatL,QscatR,QextL,QextR
c
      do 350 j =1,num
         S11 = (abs(S1(j,1))**2 + abs(S2(j,1))**2)*.5 
     1 + abs(S3(j,1))**2
          if(j.eq.1)SX=S11
         S12 = (abs(S2(j,1))**2 - abs(S1(j,1))**2)*.5
         S13 = real((S2(j,1) - S1(j,1))* conjg(S3(j,1)))
         S14 = aimag((S2(j,1) + S1(j,1))* conjg(S3(j,1)))
         S34 = aimag(S2(j,1)* conjg(S1(j,1)) - (abs(S3(j,1)))**2)
c
         write(11,10) theta(j), log10(abs(S1(j,1))**2*snorm)
         write(12,10) theta(j), log10(abs(S2(j,1))**2*snorm)
c        write(11,10) theta(j), S11
c        write(12,10) theta(j), S12
c        write(13,*) theta(j), S13
c        write(14,10) theta(j), S14
c        write(15,10) theta(j), S34

  350 continue
      write(*,'(F7.4)')SX/x**2/(QscatR+QscatL)*8.

      close(10)
      close(11)
c     close(12)
c     close(13)
c     close(14)
c     close(15)

      end
